function cost = cost_R_normalized_probability(U,mu,sigma)
% U - image of the unfolded volume
% mu and sigma - vectors of mu and sigma for the regions

probability = zeros([size(U),length(mu)]);
for i = 1:length(mu)
    probability((1:numel(U))+(i-1)*numel(U)) = 1/(sigma(i)*(2*pi).^0.5)*...
        exp(-(U(:)-mu(i)).^2/(2*sigma(i).^2));
    % this worked only for U which is 2D
    %probability(:,:,i) = 1/(sigma(i)*(2*pi).^0.5)*...
    %    exp(-(U-mu(i)).^2/(2*sigma(i).^2));    
end

d = length(size(U));
prob_norm = probability./repmat(sum(probability,d+1),[ones(1,d) length(mu)]);
cost = 1-prob_norm;