function mesh = change_geometry(mesh,vertices,change_normals)
% if there is more than one layer of vertices, mesh is transfomred into a
% cell of meshes

if size(vertices,3)==1  % only one layer
    
    mesh.vertices = vertices;
    if change_normals
        mesh.normals = vertex_normals(mesh.vertices,mesh.faces);
    end
    
else % more than one layer
    
    mesh_in = mesh;
    mesh = cell(1,size(vertices,3));
    for i = 1:size(vertices,3)
        mesh{i} = mesh_in;
        mesh{i}.vertices = vertices(:,:,i);
    end
    if change_normals
        for i = 1:size(vertices,3)
            mesh{i}.normals = vertex_normals(mesh{i}.vertices,mesh{i}.faces);
        end
    end
    
end