function mesh = explicit_laplacian_smoothing(mesh,lambda,iter)
% mesh.vertices - list of vertices 
% mesh.adjacenty - adjacency matrix defining triangle mesh 
% lambda - weight, up to 1
% iter - iterations, default 1

tic, fprintf('Explicit laplacian smoothing ... ')

if nargin<3
    iter = 1;
end

valency = sum(mesh.adjacency,2);
% making Laplacian matrix (umbrella operator) from adjacency matrix
L = double(mesh.adjacency)./repmat(valency,[1,size(mesh.adjacency,2)]);
I = speye(size(mesh.adjacency));
L = L - I;

mesh.vertices = (I+lambda*L)^iter*mesh.vertices;

disp(['finished at ',num2str(toc)])
end