function mesh = explicit_taubin_smoothing(mesh,lambda,mu,iter)
% mesh.vertices - list of vertices 
% mesh.adjacenty - adjacency matrix defining triangle mesh 
% lambda - weight
% mu - weight

tic, fprintf('Explicit taubin smoothing ... ')

if nargin<3 || isempty(mu)
    %k_pb = 0.1; % pass band frequency, for low pass between 0.001 and 0.1
    k_pb = 0.2; % for litte bit more blow up
    mu = 1/(k_pb-1/lambda); % since it must be kpb=1/lambda + 1/mu
end

if nargin<4
    iter = 1;
end

valency = sum(mesh.adjacency,2);
% making Laplacian matrix (umbrella operator) from adjacency matrix
V = spdiags(1./valency,0,numel(valency),numel(valency));
L = V*double(mesh.adjacency);
I = speye(size(mesh.adjacency));
L = L - I;

% smoothing (mu is negative)
mesh.vertices = ((I+mu*L)*(I+lambda*L))^iter*mesh.vertices;
disp(['finished at ',num2str(toc)])
end