function [C,D] = faces_to_circulator(faces)
% C is a kind of adjacency matrix, pointing to the next vertex around the
% face. If there is an edge (a,b) then is C(a,b)_c a third vertex of the 
% face (a,b,c). Matrix D contains index of the face (a,b,c) in the element
% D(a,b).

e = [faces; faces(:,[3 1 2]); faces(:,[2 3 1])];
C = sparse(e(:,1),e(:,2),e(:,3));
if nargout>1
    F = size(faces,1);
    D = sparse(e(:,1),e(:,2),repmat(1:F,[1 3]));
end
end
