function mesh = implicit_laplacian_smoothing(mesh,lambda)
% mesh.vertices - list of vertices 
% mesh.adjacenty - adjacency matrix defining triangle mesh 
% lambda - weight

tic, fprintf('Implicit laplacian smoothing ... ')

valency = sum(mesh.adjacency,2);

% making Laplacian matrix (umbrella operator) from adjacency matrix
L = double(mesh.adjacency)./repmat(valency,[1,size(mesh.adjacency,2)]);
I = speye(size(mesh.adjacency));
L = L - I;

mesh.vertices = (I-lambda*L)\mesh.vertices;

disp(['finished at ',num2str(toc)])
end