function N = vertex_normals(verts,faces)
%
% Author: Vedrana Andersen, vand@dtu.dk
% Date: 2.6.2013.

% calculating face normals
q = faces';
p = reshape((verts(q(:),:))',[9,size(faces,1)])';
nx = (p(:,5) - p(:,2)).*(p(:,9) - p(:,3)) - ...
    (p(:,6) - p(:,3)).*(p(:,8) - p(:,2));
ny = (p(:,6) - p(:,3)).*(p(:,7) - p(:,1)) - ...
    (p(:,4) - p(:,1)).*(p(:,9) - p(:,3));
nz = (p(:,4) - p(:,1)).*(p(:,8) - p(:,2)) - ...
    (p(:,5) - p(:,2)).*(p(:,7) - p(:,1));

Nf = [nx,ny,nz];
Nf = Nf./repmat(sum(Nf.^2,2).^0.5,[1,3]);

% calculating vertex normals
N = zeros(size(verts,1),3);
for v = 1:size(verts,1)
    f = logical(sum(faces == v,2));
    N(v,:) = mean(Nf(f,:));    
end

end