function V = backwards_sampling(U,mesh,q,dimV)
% Used to validate values in U
%
% Author: Vedrana Andersen Dahl, vand at dtu.dk
% Date: 9.7.2013.

X = ones(numel(q),1)*mesh.vertices(:,1)' + q(:)*mesh.normals(:,1)';
Y = ones(numel(q),1)*mesh.vertices(:,2)' + q(:)*mesh.normals(:,2)';
Z = ones(numel(q),1)*mesh.vertices(:,3)' + q(:)*mesh.normals(:,3)';

[Xq,Yq,Zq] = ndgrid(1:dimV(1),1:dimV(2),1:dimV(3));
F = TriScatteredInterp([X(:),Y(:),Z(:)],U(:));
V = F(Xq,Yq,Zq); 
        
end
