function V = bended_pipe
% makes a test volume looking like a bended pipe

dim = [200 200 200]; % volume dimensions
r_big = 50; % bend radius
r_small = 20; % pipe radius

c = (dim+1)/2;
c_pipe = c - [0 0 r_big/2];

M = zeros(dim);

for x = 1:dim(1)
    for y = 1:dim(2)
        for z = 1:dim(3)            
            alpha = atan2(x-c_pipe(1),z-c_pipe(3));
            if cos(alpha)<0
                alpha = alpha + pi;
            end
            pipe_mid = [r_big*sin(alpha)+c_pipe(1) c_pipe(2) r_big*cos(alpha)+c_pipe(3)];
             if norm([x,y,z]-pipe_mid)<r_small
                M(x,y,z)=1;
             end            
        end
    end
end

% 3d filtering with [1 1 1]
M = M + M([1 1:end-1],:,:) + M([2:end end],:,:) + M(:,[1 1:end-1],:)...
    + M(:,[2:end end],:) + M(:,:,[1 1:end-1]) + M(:,:,[2:end end]); 

M = M>0;
V = mask2data(M,[190 90],[10 20],5);
%animate_volume(V(:,:,:,1),0)

