function D = mask2data(M,mu,sigma,SIGMA)
% Takes in mask M and fills in the non-negative and negative regions with 
% intensities drawn from the normal distributions defined by mu and sigma,
% smooths out the boundary between regions with spatial SIGMA

M = double(M>0);

H = fspecial('gaussian',[5*SIGMA,1],SIGMA);
M = imfilter(M,H,'replicate');
M = imfilter(M,H','replicate');
M = imfilter(M,reshape(H,[1 1 numel(H)]),'replicate');

R = randn(size(M));

P1 = mu(1) + sigma(1)*R;
P2 = mu(2) + sigma(2)*R;

D = P1.*M + P2.*(1-M);

