function animate_volume_segmentation(V,S,p,direction,range)
% CHANGES (IN RANGE) MADE AND NOT TESTED 
% animate_volume_segmentation(V,S,p,direction,range)

tic, fprintf('Animate volume segmentation ... ')

if nargin<3
    p = 'no';
end

if nargin<4
    direction = 'xyz';
end

if nargin<5
    range_flag = false;
else
    range_flag = true;
end

V = (V-min(V(:)))/(max(V(:))-min(V(:)));
% weights for segmentation coloring
w_out = 0.5;
w_in = 0.5;

for d = 1:length(direction)
    cla, title(''), hold on, axis equal
    if direction(d)=='x'
        Vdir = permute(V,[2 3 1]);
        Sdir = permute(S,[2 3 1]);
    elseif direction(d)=='y'
        Vdir = permute(V,[3 1 2]);
        Sdir = permute(S,[3 1 2]);
    else % 'z'
        Vdir = V;
        Sdir = S;
    end
    
    L = zeros(size(Vdir,1),size(Vdir,2),3);
    
    if ~range_flag
        range = 1:size(Vdir,3);
    end
    
    for i = 1:numel(range)     
        Vslice = w_out*Vdir(:,:,range(i))+w_in;
        Sslice = 1-Sdir(:,:,range(i));
        
        L(:,:,1) = Vslice;
        L(:,:,2) = Vslice.*Sslice;
        L(:,:,3) = Vslice.*Sslice;
        image(L)
        title(['slice ',direction(d),' ',num2str(range(i)),'/',num2str(size(Vdir,3))])
        smart_pause(p)
    end
end

disp(['finished at ',num2str(toc)])

end


