function h = draw_mesh(mesh)
% mesh can also be a cell of meshes

if ~iscell(mesh) % only one mesh     
    col = [0 1 1];    
    h = patch('Faces',mesh.faces,'Vertices',mesh.vertices,...
        'FaceColor','none','EdgeColor',col);    
else  % more than one mesh    
    col =  num2cell(jet(length(mesh))',1);    
    h = cellfun(@(m,col) patch('Faces',m.faces,'Vertices',m.vertices,...
        'FaceColor','none','EdgeColor',col), mesh, col,'UniformOutput',false);    
end

end

